(defpackage "CALL-BY-REFERENCE" (:use "XLISP"))
(in-package "CALL-BY-REFERENCE")
(defun lisp-to-arg-if-not-compound-data (x)
   (if (compound-data-p x)
        x
      (if (integerp x)
          (coerce (list x) '(vector c-long))
        (coerce (list x) '(vector c-double)))))
(defun call-by-reference-oldcfun (name lib &rest args)
  "Applies function NAME from shared library handle LIB with arguments.
All compound data are passed by reference but simple ones are not."
   (let* ((fun-addr (shlib::shlib-symaddr lib name))
          (argvecs (mapcar #'lisp-to-arg-if-not-compound-data args))
          (arg-addrs (mapcar #'array-data-address argvecs)))
      (apply #'shlib::call-by-address fun-addr arg-addrs)))
(export 
        '(call-by-reference-oldcfun))
